#!/usr/bin/env node
"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const figlet_1 = __importDefault(require("figlet"));
const commander_1 = require("commander");
const hygen_1 = require("hygen");
const Logger = __importStar(require("hygen/dist/logger"));
const enquirer_1 = require("enquirer");
const path_1 = __importDefault(require("path"));
const config_1 = require("./config");
const defaultTemplates = path_1.default.join(__dirname, '_templates');
const main = () => __awaiter(void 0, void 0, void 0, function* () {
    console.log(figlet_1.default.textSync('Sertis Boilerplate'));
    const program = new commander_1.Command();
    program
        .version('0.0.1.2')
        .description('An generate CLI for managing a repository')
        .option('-i, --init', 'Init repository')
        .parse(process.argv);
    const options = program.opts();
    if (!process.argv.slice(2).length) {
        program.outputHelp();
    }
    if (options['init']) {
        const response = yield (0, enquirer_1.prompt)([
            {
                type: 'input',
                name: 'appName',
                message: 'What is app name',
                initial: 'Awesome service',
            },
            {
                type: 'select',
                name: 'template',
                message: 'What template do you want to use',
                choices: Object.values(config_1.Template),
            }
        ]);
        if (response['template']) {
            (0, hygen_1.runner)([response['template'], 'new', response['appName']], {
                templates: defaultTemplates,
                cwd: process.cwd(),
                createPrompter: () => require('enquirer'),
                logger: new Logger.default(console.log.bind(console)),
                exec: (action, body) => {
                    const opts = body && body.length > 0 ? { input: body } : {};
                    console.log('action :>> ', action);
                    console.log('opts :>> ', opts);
                },
                debug: !!process.env['DEBUG'],
            });
        }
    }
});
main();
//# sourceMappingURL=cli.js.map