"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const cross_spawn_1 = __importDefault(require("cross-spawn"));
const globby_1 = __importDefault(require("globby"));
const config_1 = require("./config");
const handler = () => __awaiter(void 0, void 0, void 0, function* () {
    for (const template of config_1.TemplateToRepo.keys()) {
        yield cross_spawn_1.default.sync('git', ['clone', config_1.TemplateToRepo.get(template), template], {
            stdio: 'inherit',
        });
        yield cross_spawn_1.default.sync('yarn', ['hygen:create:start', template], {
            stdio: 'inherit',
        });
        const paths = yield (0, globby_1.default)(`${template}/**/*`);
        yield cross_spawn_1.default.sync('yarn', ['hygen:create:add', ...paths], {
            stdio: 'inherit',
        });
        yield cross_spawn_1.default.sync('yarn', ['hygen:create:usename', template], {
            stdio: 'inherit',
        });
        yield cross_spawn_1.default.sync('yarn', ['hygen:create:generate'], {
            stdio: 'inherit',
        });
        yield cross_spawn_1.default.sync('yarn', ['delete', 'hygen-create.json'], {
            stdio: 'inherit',
        });
        yield cross_spawn_1.default.sync('yarn', ['delete', template], {
            stdio: 'inherit',
        });
        yield cross_spawn_1.default.sync('yarn', ['delete', 'src/_templates/' + template + '/new/hygen-create.json.ejs.t'], {
            stdio: 'inherit',
        });
    }
});
handler();
//# sourceMappingURL=setup.js.map